local months = {"Jan", "Feb", "Mar" , "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
local labels = 'labels : [';
local data = 'datasets : [{fillColor:"rgba(255,255,255,0)",strokeColor:"rgba(0,0,0,0.5)",pointColor:"rgba(0,0,0,0.5)",pointStrokeColor:"rgba(255,255,255,0)",data:[';
-- forecast date
local year = 0;
local month = 0;
-- Forecast line variables (Linear Regression)
local count = 0;
local count_sum = 0;
local balance_sum = 0;
local product_sum = 0;
local squared_sum = 0;

function handle_record(record)
    year = record:get("YEAR");
    month = record:get("MONTH");
    local date = months[tonumber(month)] .. ' ' .. year;
    labels = labels .. '"' .. date .. '",';
    record:set("DATE", date);
    local balance = string.format("%.2f", tonumber(record:get("Balance")));
    if tonumber(string.sub(balance,-1)) == 0  and tonumber(string.sub(balance,-2)) ~= 0 then
        data = data .. '\'' .. balance .. '\',';
    else
        data = data .. balance .. ',';
    end
-- Update forecast line calculation values
    local x = count + 1;
    count = count + 1;
    count_sum = count_sum + x;
    balance_sum = balance_sum + balance;
    product_sum = product_sum + (x * balance);
    squared_sum = squared_sum + (x * x);
end

function complete(result)
    local year = year;
    local month = month;
-- Forecast line equation
    local slope = ((count * product_sum) - (count_sum * balance_sum)) / ((count * squared_sum) - (count_sum * count_sum));
    local intercept = (balance_sum - (slope * count_sum)) / count;
-- Forecast line values
    data = string.sub(data,1,-2) .. ']},{fillColor:"rgba(255,255,255,0)",strokeColor:"rgba(255,0,0,0.5)",pointColor:"rgba(255,0,0,0.5)",pointStrokeColor:"rgba(255,255,255,0)",data:[';
    for i=1,count do
        data = data .. ',';
    end
    for i=1,12 do
        -- Label
        month = month + 1;
        if month > 12 then
            year = year + 1;
            month = 1;
        end
        local date = months[tonumber(month)] .. ' ' .. year;
        labels = labels .. '"' .. date .. '",';
        result:set('FLABEL' .. i, date);
        -- Value
        local value = (slope * (count + i)) + intercept;
        local fval = string.format("%.2f", value);
        if tonumber(string.sub(fval,-1)) == 0  and tonumber(string.sub(fval,-2)) ~= 0 then
            data = data .. '\'' .. fval .. '\',';
        else
            data = data .. fval .. ',';
        end
        result:set('FVALUE' .. i, string.format("%.2f", value));
    end
    result:set('TREND_DATA', string.sub(labels,1,-2) .. "]," .. string.sub(data,1,-2) .. "]}]");
end
